// Prof Simo - DAINF/UTFPR - Ctba - TecProg S71 - 1 Sem 2025 - 1a Parcial
// Hah couts e elses suplementares para fins de entendimento da execuo.

#include <list>
//#include <vector>
#include <iostream>
using namespace std;

#include <stdlib.h>
#include <time.h>

void semente()
{
    time_t t;                   // https://pt.wikipedia.org/wiki/Time_t
    srand((unsigned) time(&t)); // Para funo srand e rand vide: https://www.tutorialspoint.com/c_standard_library/c_function_srand.htm
}

class Animal
{
    private:
        int forca;

    public:

        Animal(const int f = 0):forca (f) { semente(); }
        virtual ~Animal() { forca = -1; }

        virtual const int getForca() const { return forca;} // virtual apenas porque o enunciado manda...

        void operator--() { forca--; }
        void operator++() { forca++; }

        virtual void executar() = 0;
};

class Formiga : public Animal
{
    private:
        bool ferrao;

    public:

        Formiga(const int f = 0):
            Animal(f),
            ferrao(false)
        {
            semente();
            if ( (rand()%10)==1 )
            {
                ferrao = true;
            }
        }

        ~Formiga() { }

        void setFerrao(const bool f) { ferrao = f; } // at o implementei mas no  usado finalmente...
        const int getFerrao() const { return ferrao; }

        void executar()
        {
            (rand()%10)<6 ? operator++() : operator--();
        }
};

class Formigal
{
    private:
        //vector<Formiga*> forms;
        //vector<Formiga*>::iterator it;
        list<Formiga*> forms;
        list<Formiga*>::iterator it;

    public:

        Formigal(): forms(), it()
        {
            semente();
            forms.clear();
            primeiro();
        }

        ~Formigal()
        {
            for (it=forms.begin(); it != forms.end(); it++)
            {
                if (*it)
                {
                    cout << "Deletando formiga: " << *it << endl;
                    delete *it;
                    *it = NULL;
                }
                else
                {
                    cerr << "Iterador apontando para elemento nulo: " << *it << endl;
                }
            }
            forms.clear();
        }

        void primeiro()
        {
            it = forms.begin();
        }

        void operator++()
        {
            if (!ultimo()) { it++; } else { cerr << "Passou do final de forms em Formigal!" << endl; }
        }

        Formiga* atual() const
        {
            return *it;
        }

        void eliminar()
        {
            if (!forms.empty())
            {
                if (*it)
                {
                    delete *it;
                    *it = NULL;
                }
                else
                {
                    cerr << "P onteiro de formiga nulo em formigal! " << endl;
                }
                forms.erase(it);
            }
            else
            {
                cerr << "Forms vazio! " << endl;
            }
        }

        const bool ultimo() const // interpretei o ltimo como o fim efetivo...
        {
            //if (it == forms.end()) { return true; } else { return false; }
            return (it == forms.end());
        }

        void incluir(Formiga* p)
        {
            if (p) { forms.push_back(p); }
            else { cerr << "Ponteiro nulo - sem incluso!" << endl; }
        }

        void executar()
        {
            for ( it = forms.begin(); it != forms.end(); it++)
            {
                if (*it)
                {
                    //cout << endl;
                    (*it)->executar();
                }
                else
                {
                    cerr << "Ponteiro nulo no conjunto" << endl;
                }
            }
            cout << endl;

            primeiro();
        }
};

class Tamandua : public Animal
{
    private:
        Formigal* pForms;

    public:

        Tamandua(const int f = 0): Animal(f), pForms(NULL)
        {
            semente();
        }

        ~Tamandua() { pForms = NULL; }

        void setForms(Formigal* pF) { pForms = pF; }
        //pForms* getForms() const { return pForms; }

        void executar()
        {
            if (!pForms) { cerr << "pForms nulo!" << endl; return; }

            const int max = 100;

            pForms->primeiro();

            Formiga* pF = NULL;

            cout << "Em vias de entrar no loop. " << endl;

            int cont = 1;

            while (pForms->ultimo()!= true)
            {
                cout << "Agora j no loop " << endl;

                pF = NULL;
                pF = pForms->atual();

                if ( pF )
                {
                    if  (   ( pF->getFerrao() == false ) ||
                            ( pF->getForca() < max )
                        )
                    {
                        operator++();
                        cout    << cont << " Formiga neutralizada: " << pForms
                                << " ferro: " << pF->getFerrao()
                                << " fora:  " << pF->getForca()
                                << endl;
                        pForms->eliminar(); // se for vector
                    }
                    else
                    {
                        cout    << cont << " Formiga sobrevivente: " << pForms
                                << " ferro: " << pF->getFerrao()
                                << " fora:  " << pF->getForca()
                                << endl;
                        //pForms->operator++(); // se for vector
                    }
                }
                else
                {
                    cerr << cont << " Ponteiro de formiga nulo!" << endl;
                    //pForms->operator++(); // se for vector
                }
                cont++;
                pForms->operator++(); // se for list
            }

            cout << "Depois do loop!" << endl;

            pForms->primeiro();
        }
};

class Habitat
{
    private:
        Formigal* pForms;
        Tamandua* pTaman;

        const int maxforms;
        int contforms;

    public:

        Habitat():
            pForms(NULL),
            pTaman(NULL),
            maxforms(20),
            contforms(10)
        {
            semente();

            criarAnimais();
            executar();
        }

        ~Habitat()
        {
            if (pForms)
            {
                delete pForms;
                pForms = NULL;
            }

            if (pTaman)
            {
                delete pTaman;
                pTaman = NULL;
            }
        }

    private:

        void criarAnimais()
        {
            pForms = new Formigal();

            if (!pForms)
            {
                cout << "Formigal Nulo!" << endl;
                return;
            }

            //system("Pause");
            //pForms->operator++();
            //pForms->eliminar();
            //system("Pause");

            pTaman = new Tamandua(contforms);
            if (pTaman)
            {
                 pTaman->setForms(pForms);
            }
            else
            {
                cerr << "Tamandu Nulo!" << endl;
                return;
            }

            Formiga* pFormiga = NULL;

            for (int i = 0; i < maxforms; i++)
            {
                contforms+=10;
                pFormiga = new Formiga(contforms);

                if (pFormiga)
                {
                    pForms->incluir(pFormiga);
                    cout << "Formiga alocada e incluida no FORMIGAL!" << endl;
                }
                else
                {
                    cerr << "Formiga no alocada!" << endl;
                }
                pFormiga = NULL;
            }
            system("pause");
        }


        void executar()
        {
            if (pForms)
            {
                pForms->executar();
            }
            else
            {
                cerr << "pForms nulo!" << endl;
            }

            cout << endl;

            if (pTaman)
            {
                pTaman->executar();
                cout << "A fora do Tamandu : " << pTaman->getForca() << endl;
            }
            else
            {
                cerr << "pForms nulo!" << endl;
            }
            cout << endl;

            if (pForms)
            {
                int cont = 0;
                pForms->primeiro();
                while (pForms->ultimo()==false)
                {
                    cont++;
                    pForms->operator++();
                }
                cout << "A quantia de formigas sobreviventes : " << cont << endl;
            }
            else
            {
                cerr << "pForms nulo!" << endl;
            }
        }
};

int main()
{
    semente();

    Habitat habitat;

    cout << endl;
    cout << "FIM" << endl;

    return 0;
}

